@echo off
REM USAGE: mkrelease RELVERSION RELYEAR

IF "%1%"=="" (
	echo Usage: %0 releaseversion releaseyear
	exit /B
)
IF "%2%"=="" (
	echo Usage: %0 releaseversion releaseyear
	exit /B
)

REM **************************************************
REM ** at first, make the platform independent version
REM **************************************************

rmdir /s /q temp

echo *** Building platform independent version ***

REM Create Directory Structure
echo Creating directory structure ...
mkdir temp
mkdir temp\common
mkdir temp\perl
mkdir temp\perl\sadmin
mkdir temp\perl\cadmin
mkdir temp\php

REM Copy and process files and remove debug print lines from perl scripts
echo Copying and processing files ...
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	readme.html						>temp\readme.html
copy /Y											common\*						temp\common
copy /Y											perl\httptunnel_client.cfg.txt	temp\perl\httptunnel_client.cfg
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\httptunnel_client.pl		| perl -n -e "m/^#print/ or print;" >temp\perl\httptunnel_client.pl
copy /Y											perl\httptunnel_server.cfg.txt	temp\perl\httptunnel_server.cfg
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\httptunnel_server.pl		| perl -n -e "m/^#print/ or print;" >temp\perl\httptunnel_server.pl
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\HTTPTunnelLib.pm			| perl -n -e "m/^#print/ or print;" >temp\perl\HTTPTunnelLib.pm
copy /Y											perl\sadmin\*					temp\perl\sadmin
copy /Y											perl\cadmin\*					temp\perl\cadmin
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\admin.php					>temp\php\admin.php
copy /Y											php\cfg.php.txt					temp\php\cfg.php
copy /Y											php\htaccess.txt				temp\php\htaccess.txt
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\lib.php						>temp\php\lib.php
ppp.pl -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\tunnel.php					>temp\php\tunnel.php

REM zip all contents and delete the directory again
echo Zipping directory ...
rmdir /s /q HTTPTunnel_v%1
del /q HTTPTunnel_v%1_platformindependent.zip
del /q HTTPTunnel_v%1_platformindependent.tgz
ren temp HTTPTunnel_v%1
zip -9 -r HTTPTunnel_v%1_platformindependent.zip HTTPTunnel_v%1
tar czf HTTPTunnel_v%1_platformindependent.tgz HTTPTunnel_v%1
rmdir /s /q HTTPTunnel_v%1

REM **************************************************
REM ** now, the source release
REM **************************************************

rmdir /s /q temp
echo *** Building Source version ***

REM Copy files
echo Copying files ...
mkdir temp
mkdir temp\common
mkdir temp\perl
mkdir temp\perl\sadmin
mkdir temp\perl\cadmin
mkdir temp\php

copy /Y	common\*						temp\common
copy /Y	perl\httptunnel_client.cfg.txt	temp\perl
copy /Y perl\httptunnel_client.pl		temp\perl
copy /Y	perl\httptunnel_server.cfg.txt	temp\perl
copy /Y perl\httptunnel_server.pl		temp\perl
copy /Y perl\HTTPTunnelLib.pm			temp\perl
copy /Y perl\runclient.bat				temp\perl
copy /Y perl\runserver.bat				temp\perl
copy /Y perl\w32runclient.bat			temp\perl
copy /Y perl\w32runserver.bat			temp\perl
copy /Y	perl\sadmin\*					temp\perl\sadmin
copy /Y	perl\cadmin\*					temp\perl\cadmin
copy /Y php\admin.php					temp\php
copy /Y	php\cfg.php.txt					temp\php
copy /Y	php\htaccess.txt				temp\php
copy /Y php\lib.php						temp\php
copy /Y php\tunnel.php					temp\php
copy /Y HTTPTunnel.aip					temp
copy /Y client_exe.ico					temp
copy /Y mkrelease.bat					temp
copy /Y ppp.pl							temp
copy /Y readme.html						temp
copy /Y server_exe.ico					temp

REM zip all contents and delete the directory again
echo Zipping directory ...
rmdir /s /q HTTPTunnel_v%1_src
del /q HTTPTunnel_v%1_sources.tgz
ren temp HTTPTunnel_v%1_src
tar czf HTTPTunnel_v%1_sources.tgz HTTPTunnel_v%1_src
rmdir /s /q HTTPTunnel_v%1_src

REM **************************************************
REM ** now, make the WIN32 version
REM **************************************************

rmdir /s /q temp

echo *** Building WIN32 version ***

REM Create Directory Structure
echo Creating directory structure ...
mkdir temp
mkdir temp\common
mkdir temp\perl
mkdir temp\perl\sadmin
mkdir temp\perl\cadmin
mkdir temp\php

REM Copy and process files remove debug print lines from perl scripts
echo Copying and processing files ...
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	readme.html						>temp\readme.html
copy /Y													common\*						temp\common
copy /Y													perl\httptunnel_client.cfg.txt	temp\perl\httptunnel_client.cfg
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\httptunnel_client.pl		| perl -n -e "m/^#print/ or print;" >temp\perl\httptunnel_client.pl
copy /Y													perl\httptunnel_server.cfg.txt	temp\perl\httptunnel_server.cfg
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\httptunnel_server.pl		| perl -n -e "m/^#print/ or print;" >temp\perl\httptunnel_server.pl
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	perl\HTTPTunnelLib.pm			| perl -n -e "m/^#print/ or print;" >temp\perl\HTTPTunnelLib.pm
copy /Y													perl\sadmin\*					temp\perl\sadmin
copy /Y													perl\cadmin\*					temp\perl\cadmin
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\admin.php					>temp\php\admin.php
copy /Y													php\cfg.php.txt					temp\php\cfg.php
copy /Y													php\htaccess.txt				temp\php\htaccess.txt
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\lib.php						>temp\php\lib.php
ppp.pl -DWIN32 -DRELEASE -DRELVERSION=%1 -DRELYEAR=%2	php\tunnel.php					>temp\php\tunnel.php

REM compile the perl scripts
echo Compiling the scripts ...
cd temp\perl
cmd /c pp -v 1 --gui --compile --clean --compress=9 --icon=../../client_exe.ico --output=httptunnel_client.exe httptunnel_client.pl
cmd /c pp -v 1 --gui --compile --clean --compress=9 -icon=../../server_exe.ico --output=httptunnel_server.exe httptunnel_server.pl
del httptunnel_client.pl httptunnel_server.pl HTTPTunnelLib.pm
del /q par*.exe
cd ..
ren perl exe
cd ..

REM make the installation package
echo Making installation package
del temp.exe
cmd /c "C:\Program Files\Advanced Installer\AdvancedInstaller.com" /edit HTTPTunnel.aip /SetVersion %1 -noprodcode
cmd /c "C:\Program Files\Advanced Installer\AdvancedInstaller.com" /build HTTPTunnel.aip
del HTTPTunnel_v%1_win32.exe
ren temp.exe HTTPTunnel_v%1_win32.exe
rmdir /s /q HTTPTunnel-cache
REM rmdir /s /q temp
